//------------------------------------------------|
// C Header File																	|
// Created 11/9/00; 2:58:56 PM										|
//------------------------------------------------|
//All code was done by Sean Kelly, www.skti.org   |
//Feel free to use it, but give me some credit    |
//------------------------------------------------|

void plmasker()
{
	Sprite8(x,y+4,16,plmask,plane2,SPRT_AND);
	Sprite8(x,y+4,16,plmask,plane1,SPRT_AND);
}

void DrawNormalRight()
{
	Sprite8(x,y+4,16,fRhtStill2,plane2,SPRT_OR);
	Sprite8(x,y+4,16,fRhtStill1,plane1,SPRT_OR);
}

void DrawWalkRight()
{
	Sprite8(x,y+4,16,fRhtWalk2,plane2,SPRT_OR);
	Sprite8(x,y+4,16,fRhtWalk1,plane1,SPRT_OR);
}

void DrawNormalLeft()
{
	Sprite8(x,y+4,16,fLftStill2,plane2,SPRT_OR);
	Sprite8(x,y+4,16,fLftStill1,plane1,SPRT_OR);	
}

void DrawWalkLeft()
{
	Sprite8(x,y+4,16,fLftWalk2,plane2,SPRT_OR);
	Sprite8(x,y+4,16,fLftWalk1,plane1,SPRT_OR);
}

void DrawJRight()
{
	Sprite8(x,y+4,16,rJump2,plane2,SPRT_OR);
	Sprite8(x,y+4,16,rJump1,plane1,SPRT_OR);	
}

void DrawJLeft()
{
	Sprite8(x,y+4,16,lJump2,plane2,SPRT_OR);
	Sprite8(x,y+4,16,lJump1,plane1,SPRT_OR);
}

void walkRight(int w)
{
	if(what==4)
		what=0;
	if(what<=1)
		DrawWalkRight();
	if(what>=2)
		DrawNormalRight();
	if(w) what++;
}

void walkLeft(int w)
{
	if(what==4)
		what=0;
	if(what<=1)
		DrawWalkLeft();
	if(what>=2)
		DrawNormalLeft();
	if(w) what++;
}

void DrawPL()
{
	plmasker();
	if(!(fall) && !(jT))
		{
			if(face)
				walkLeft(0);
			else
				walkRight(0);
		}
	else
		{
			if(face)
				DrawJLeft();
			else
				DrawJRight();
		}
}

#include "collision.h"

void waste()
{
	for(time=0;time<=timer;time++) {}
}

void Jump()
{
	if(CheckUp())
		{
			if(y!=18) y=y-2;
			if(face)
				DrawJLeft();
			else
				DrawJRight();
			if(arrow==0)
				waste();
			tmpy++;
			if(tmpy==16)
				{
					jT=0;
					fall=1;
					tmpy=0;
					plmasker();
				}
			}
	else
		{
			checkQbox();
			tmpy=0;
			jT=0;
			fall=1;
		}
}

void drawFall() 
{
	if(checkDown())
		{
			fall=0;
			DrawPL();
		}
	else
		{
			y=y+2;
			if(face)
				DrawJLeft();
			else
				DrawJRight();
			if(arrow==0)
				waste();
		}
}

void plLoop()
{
	int jumped=0;
	jumped=_rowread(5);							// low level key access
	if(jumped==-128 && fall!=1)			// if you press F1, set jT
		{
			jT=1;
			jumped=0;
		}
	plmasker();											// erase character
	check=x+viewx*8;								// set place in map to check
	if(arrow==4)										// if press right...
		{
			face=0;
			if(x==152 && screen==4);
			else
				{
					if(checkNormalRight() && !(jT) && !(fall)) // if nothing to right
						{
							x++;						// add one to x
							walkRight(1);		// draw character walking
						}
					else if(jT && checkJumpRight())	 // if jumping, and path is clear
						x++;
					else if(fall && checkFallRight())		// if falling, and path is clear
						x++;
				}
		}
	if(arrow==2)   // same as right, but for left
		{
			face=1;
			if(x!=0)
				{
					if(checkNormalLeft() && !(jT) && !(fall))
						{
							x--;
							walkLeft(1);
						}
					else if(jT && checkJumpLeft())
						x--;
					else if(fall && checkFallLeft())
						x--;
				}
		}
	check=x+viewx*8;								// set place in map to check
	if(map[y/8][check/8].type<3 && !(jT))   // if nothing is beneath you,
		fall=1;																		 // make char. fall
	if(map[y/8][check/8].type==15 && !(jT))	 // if stand on end point
		end=1;																		 // set end so level ends
	checkCollect(8);								  // checks feet for bolts
	checkCollect(16);									// checks head for bolts
	if(arrow==0)											// if you are not moving
		what=3;													// set it so normal character is displayed
	if(!(fall) && !(jT))			// if not jumping or falling		
		DrawPL();												// draw character
	else															// if jumping or falling
		plmasker();											// clear new area for character
	if(fall)													// if falling
		drawFall();											// fall
	if(jT)										// if you are jumping
		{
			Jump();												// jump
			key=0;												// initialize key
		}
	if(checkEnemies()) dead=1;				// if you hit an enemy, die
	if(enemies())											// sets how much time to waste
		{
			if(yes<3)
				timer=speed-yes*750;
			else
				timer=speed-yes*400;
			if(arrow>0) timer=timer-(yes*200);
		}
	else
		timer=speed+2000;
	waste();							// wastes time
}
