// C Header File
// Created 10/15/00; 11:05:17 AM

unsigned char LndLftTop2[]={ 0x4A, 0x3B, 0x7F, 0xFC, 0xD3, 0xFE, 0xD9, 0xD7};
unsigned char LndLftTop1[]={0x4A,0x3B,0x6E,0xC3,0xAC,0x81,0xA6,0xA8};

unsigned char LndMidTop2[]={ 0x85, 0xD5, 0xFB, 0xBF, 0xDD, 0xF3, 0x9F, 0xFB};
unsigned char LndMidTop1[]={0x85,0x55,0x2A,0x44,0x22,0xC,0x60,0x4};

unsigned char LndRhtTop2[]={ 0x52, 0xDC, 0xFE, 0x3F, 0xCB, 0x7F, 0x9B, 0xEB};
unsigned char LndRhtTop1[]={0x52,0xDC,0x76,0xC3,0x35,0x81,0x65,0x15};

unsigned char LndLftMid2[]={ 0x77, 0xC9, 0x7B, 0x32, 0xCB, 0xBF, 0x5B, 0xEB};
unsigned char LndLftMid1[]={0x68,0xB6,0x44,0x2D,0xF4,0xA0,0x64,0x94};

unsigned char LndMidMid2[]={ 0xF7, 0x49, 0xFB, 0x32, 0xCB, 0x7E, 0x9B, 0xEB};
unsigned char LndMidMid1[]={0x8,0xB6,0x4,0xCD,0x34,0x81,0x64,0x14};

unsigned char LndRhtMid2[]={ 0xEE, 0x93, 0xDE, 0x4C, 0xD3, 0x7D, 0xDA, 0xD7};
unsigned char LndRhtMid1[]={0x16,0x6D,0x22,0xB4,0x2F,0x85,0x26,0x29};

unsigned char LndLftBot2[]={ 0xD7, 0xD9, 0xFE, 0xD3, 0xFC, 0x7F, 0x3B, 0x4A};
unsigned char LndLftBot1[]={0xA8,0xA6,0x81,0xAC,0xC3,0x6E,0x3B,0x4A};

unsigned char LndMidBot2[]={ 0xFD, 0x9F, 0xF3, 0xDD, 0xBF, 0xFB, 0xD5, 0x85};
unsigned char LndMidBot1[]={0x2,0x60,0xC,0x22,0x44,0x2A,0x55,0x85};

unsigned char LndRhtBot2[]={ 0xEB, 0x9B, 0x7F, 0xCB, 0x3F, 0xFE, 0xDC, 0x52};
unsigned char LndRhtBot1[]={0x15,0x65,0x81,0x35,0xC3,0x76,0xDC,0x52};

unsigned char qbox2[]={ 0x7E, 0x9B, 0xA7, 0x87, 0x8B, 0x87, 0xFF, 0x7E};
unsigned char qbox1[]={0x7E,0xFD,0xFD,0xFD,0xFD,0xF9,0x89,0x7E};

unsigned char box2[]={ 0x7E, 0x83, 0xA7, 0x83, 0x83, 0xA7, 0xFF, 0x7E};
unsigned char box1[]={0x7E,0xFD,0xFD,0xFD,0xFD,0xFD,0x81,0x7E};

unsigned char end2[]={0x3C,0x3C,0x18,0x0,0x0,0x7E,0x8F,0xFF};
unsigned char end1[]={0x6A,0x56,0x42,0x42,0xC3,0xFF,0xF1,0xFF};

unsigned char chstart2[]={0x3C,0x42,0xA7,0x83,0xA7,0x9B,0x7E,0x3C};
unsigned char chstart1[]={0x3C,0x7E,0xFD,0xFD,0xFD,0xFD,0x42,0x3C};

unsigned char dmbEnemy2[]={0x3C,0x7E,0xDB,0xE7,0x7E,0xE7,0xDB,0xE7};
unsigned char dmbEnemy1[]={0x3C,0x42,0xBD,0xBD,0x7E,0x99,0xBD,0xE7};

unsigned char midEnemy2[]={0x1C,0x26,0x57,0x97,0x87,0xAF,0xFE,0x7C};
unsigned char midEnemy1[]={0x1C,0x3A,0x7D,0xFD,0xF9,0xF1,0x82,0x7C};

unsigned char flyEnemy2[]={0x7E,0x81,0xA5,0xE7,0x7E,0x66,0x7D,0x49};
unsigned char flyEnemy1[]={0x7E,0xFF,0xFF,0xBD,0x42,0x5A,0x7D,0x49};

unsigned char bolt2[]={0x1C,0x38,0x70,0x6C,0x32,0x64,0x78,0x60};
unsigned char bolt1[]={0x1C,0x28,0x50,0x5C,0x2E,0x5C,0x58,0x60};

unsigned char mask[]={0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0};

unsigned char erase[]={ 0xFF, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0xFF};

void masker(int x, int y)
{
	Sprite8(x,y,8,mask,plane2,SPRT_AND);
	Sprite8(x,y,8,mask,plane1,SPRT_AND);
}

void eraser(int x, int y)
{
	Sprite8(x,y,8,erase,plane2,SPRT_OR);
}
 
void qbox(int x, int y)
{
	Sprite8(x,y,8,qbox2,plane2,SPRT_OR);
	Sprite8(x,y,8,qbox1,plane1,SPRT_OR);
}

void lftlndtop(int x, int y)
{
	Sprite8(x,y,8,LndLftTop2,plane2,SPRT_OR);
	Sprite8(x,y,8,LndLftTop1,plane1,SPRT_OR);	
}

void midlndtop(int x, int y)
{
	Sprite8(x,y,8,LndMidTop2,plane2,SPRT_OR);
	Sprite8(x,y,8,LndMidTop1,plane1,SPRT_OR);	
}

void rhtlndtop(int x, int y)
{
	Sprite8(x,y,8,LndRhtTop2,plane2,SPRT_OR);
	Sprite8(x,y,8,LndRhtTop1,plane1,SPRT_OR);	
}

void lftlndmid(int x, int y)
{
	Sprite8(x,y,8,LndLftMid2,plane2,SPRT_OR);
	Sprite8(x,y,8,LndLftMid1,plane1,SPRT_OR);	
}

void midlndmid(int x, int y)
{
	Sprite8(x,y,8,LndMidMid2,plane2,SPRT_OR);
	Sprite8(x,y,8,LndMidMid1,plane1,SPRT_OR);	
}

void rhtlndmid(int x, int y)
{
	Sprite8(x,y,8,LndRhtMid2,plane2,SPRT_OR);
	Sprite8(x,y,8,LndRhtMid1,plane1,SPRT_OR);	
}

void lftlndbot(int x, int y)
{
	Sprite8(x,y,8,LndLftBot2,plane2,SPRT_OR);
	Sprite8(x,y,8,LndLftBot1,plane1,SPRT_OR);	
}

void midlndbot(int x, int y)
{
	Sprite8(x,y,8,LndMidBot2,plane2,SPRT_OR);
	Sprite8(x,y,8,LndMidBot1,plane1,SPRT_OR);	
}

void rhtlndbot(int x, int y)
{
	Sprite8(x,y,8,LndRhtBot2,plane2,SPRT_OR);
	Sprite8(x,y,8,LndRhtBot1,plane1,SPRT_OR);	
}

void box(int x, int y)
{
	Sprite8(x,y,8,box2,plane2,SPRT_OR);
	Sprite8(x,y,8,box1,plane1,SPRT_OR);
}

void endPiece(int x,int y)
{
	Sprite8(x,y,8,end2,plane2,SPRT_OR);
	Sprite8(x,y,8,end1,plane1,SPRT_OR);
}

void smiley(int x,int y)
{
	Sprite8(x,y,8,chstart2,plane2,SPRT_OR);
	Sprite8(x,y,8,chstart1,plane1,SPRT_OR);
}

void bolt(int x,int y)
{
	Sprite8(x,y,8,bolt2,plane2,SPRT_OR);
	Sprite8(x,y,8,bolt1,plane1,SPRT_OR);
}

void oneDirEnemy(int x,int y)
{
	Sprite8(x,y,8,dmbEnemy2,plane2,SPRT_OR);
	Sprite8(x,y,8,dmbEnemy1,plane1,SPRT_OR);
}

void twoDirEnemy(int x,int y)
{
	Sprite8(x,y,8,midEnemy2,plane2,SPRT_OR);
	Sprite8(x,y,8,midEnemy1,plane1,SPRT_OR);
}

void flyingEnemy(int x,int y)
{
	Sprite8(x,y,8,flyEnemy2,plane2,SPRT_OR);
	Sprite8(x,y,8,flyEnemy1,plane1,SPRT_OR);
}
